# class IRB::ColorPrinter

### Public Class Methods

pp(obj, out = $>, width = screen_width) click to toggle source

    # File lib/irb/color_printer.rb, line 8
    def pp(obj, out = $>, width = screen_width)
      q = ColorPrinter.new(out, width)
      q.guard_inspect_key {q.pp obj}
      q.flush
      out << "\n"
    end

### Private Class Methods

screen_width() click to toggle source

    # File lib/irb/color_printer.rb, line 17
    def screen_width
      Reline.get_screen_size.last
    rescue Errno::EINVAL # in `winsize': Invalid argument - <STDIN>
      79
    end

### Public Instance Methods

pp(obj) click to toggle source
Calls superclass method `PP::pp`

    # File lib/irb/color_printer.rb, line 24
    def pp(obj)
      if obj.is_a?(String)
        # Avoid calling Ruby 2.4+ String#pretty_print that splits a string by "\n"
        text(obj.inspect)
      else
        super
      end
    end

text(str, width = nil) click to toggle source
Calls superclass method `PrettyPrint#text`

    # File lib/irb/color_printer.rb, line 33
    def text(str, width = nil)
      unless str.is_a?(String)
        str = str.inspect
      end
      width ||= str.length

      case str
      when ''
      when ',', '=>', '[', ']', '{', '}', '..', '...', /\A@\w+\z/
        super(str, width)
      when /\A#</, '=', '>'
        super(Color.colorize(str, [:GREEN]), width)
      else
        super(Color.colorize_code(str, ignore_error: true), width)
      end
    end